Subject: Re: bug#60845: 30.0.50; [PATCH] Add tests for Eshell interactive completion (and fix a bug in it)

From: Jim Porter <[email-masked]>
Date: Tue, 5 Sep 2023 17:47:06 -0700

On 9/5/2023 4:36 PM, Stefan Kangas wrote:
> Jim Porter <[email-masked]> writes:
> 
>> On 1/30/2023 6:54 AM, Stefan Monnier via Bug reports for GNU Emacs, the Swiss
>> army knife of text editors wrote:
>>> It sounds good to me, but I'm definitely not well versed in this aspect
>>> of the interaction between Eshell and Pcomplete (more specifically,
>>> this is a part of their interaction which I find quite tricky), so it's
>>> good that you add corresponding regression tests.
>>
>> Thanks for taking a look. I've merged my patches as e7d0aa248e. We can leave
>> this open though to discuss what to do about the Pcomplete side of things. I
>> think we can remove the workaround for Emacs 29, but maybe we want some
>> additional changes.
> 
> That was 9 months ago.  Is it still relevant to keep this bug open?

Yes, I believe so. I was planning to wait until Emacs 29.1 was released 
before pinging people on this, but then forgot all about it. We should 
probably use this time to fix the FIXME in 'pcomplete-arg', since (I 
think) the current behavior in Eshell no longer requires the FIXME bit:

             ;; FIXME: 'last' is handled specially in Emacs 29, because
             ;; 'pcomplete-parse-arguments' accepts a list of strings
             ;; (which are completion candidates) as return value for
             ;; (pcomplete-arg 'last).  See below: "it means it's a
             ;; list of completions computed during parsing,
             ;; e.g. Eshell uses that to turn globs into lists of
             ;; completions".  This special case will be dealt with
             ;; differently in Emacs 30: the pcomplete-arg-value
             ;; property will be used by 'pcomplete-parse-arguments'.